//adds debt[23..0] to add[23..0] and puts result in debt[23..0]

//this works just like we were taught long adding in school

void update_debt(void)
{
	char i;
	
	for (i=0;i<=23;i++)
	{
		digit[i]=digit[i]+add[i];
		if ( (digit[i]>=10) && (i<=22) )
		{
			digit[i]-=10;
			digit[i+1]++;
		}
	}
}

//takes digits in digit[23..0] and shifts them into the external led drivers
//goes out most significant digit first
//according to data sheet, data must be present before rising edge of clock

//at 16Mhz, 4MIPS, there is 0.25us = 250ns between each instruction

//takes <2ms @ 16MHz

void setup_digit_shift_ports(void)
{
	//see interrupt routine task x for setting up ports,
	//	if power is on, the relevant ports are outputs,
	//	if power is off, the relevant ports are tri-stated to inputs
	TRISB=0b11001001;
	TRISC=0b11000000;
	TRISD=0b11110000;
}

void tristate_digit_shift_ports(void)
{
	//set all ports to input
	TRISB=0xFF;
	TRISC=0xFF;
	TRISD=0xFF;
}

unsigned char shift;

void digit_shift(void)
{


/*

this section sets up macros to change multiple ports at once
for clock, strobe, and data

-	cannot use RB0=1;RB1=1;RB2=1; etc because it will switch the
	ports on sequentially
-	we CANNOT | or & the port directly, its been tested and when
	both the interrupts and the main access the same port, it bombs

*/

#define clock_hi tempport=PORTB;bits_on(tempport,0b00110110);PORTB=tempport
#define clock_lo tempport=PORTB;bits_off(tempport,0b00110110);PORTB=tempport

#define strobe_hi tempport=PORTD;bits_on(tempport,0b00001111);PORTD=tempport
#define strobe_lo tempport=PORTD;bits_off(tempport,0b00001111);PORTD=tempport

#define data_hi tempport=PORTC;bits_on(tempport,0b00110000);PORTC=tempport
#define data_lo tempport=PORTC;bits_off(tempport,0b00110000);PORTC=tempport

#define oe_bar_hi tempport=PORTC;bits_on(tempport,0b00001111);PORTC=tempport
#define oe_bar_lo tempport=PORTC;bits_off(tempport,0b00001111);PORTC=tempport

	signed char i,j;
	unsigned char skip_leading_zeros;
	unsigned char tempport;

//leave this to the oe_bar brightness controller in interrupt routine
//	oe_bar_lo;	//turn on display
	
	strobe_lo;

	//shift out top 16 digits, bottom 8 are not displayed
	//	and are only present to reduce rounding errors

	//leading zeros are blanked

	skip_leading_zeros=TRUE;
	for (i=23;i>=8;i--)
	{
		if ( (digit[i]>0) || (skip_leading_zeros==FALSE) )
		{
			skip_leading_zeros=FALSE;
			shift=segment[digit[i]];		//segment[i] contains pattern like on calculator display
																	//	to make '0' from 0, '8' from 8, etc
		}
		else
		{
			shift=0;	//blank leading zeros
		}
		
		//shift out bits, lsb first
		clock_lo;
		for (j=0;j<=7;j++)
		{
			if ((shift>>j) & 0b00000001)
			{
				data_hi;
				b;
			}
			else
			{
				data_lo;
				b;
			}
			dly250n;
			clock_hi;
			dly250n;
			clock_lo;
		}
	}
	dly500n;
	strobe_hi;
	dly500n;
	strobe_lo;
}
